#include <stdio.h>
#include <stdlib.h>
#include <string.h>

main(int argc, char *argv[]) {
  int XSIZ, YSIZ;
  int i, x, y , m;
  int numImages, numSigs, numPts;
  int totalMag;
  FILE *fp[20];
  FILE *fd[2];

  char dir[][40] = {"../bird/", "../bridge/", "../camera/", "../circles/",
                    "../crosses/", "../goldhill/", "../horiz/", "../lena/",
                    "../montage/", "../slope/", "../text/"};

  if (argc < 2) {
     printf("Usage:  createPDF [XSIZ] [YSIZ] [#images] [outfile] [infile]\n");
     exit(0);
  } else {
     XSIZ = atoi(argv[1]); 
     YSIZ = atoi(argv[2]); 
     numImages = atoi(argv[3]);
  }
 
  for (i=0; i < numImages; i++) {
     strcat(dir[i], argv[5]); 
     fp[i] = fopen(dir[i], "r");
     if (!fp[i]) {
        printf("error opening file i\n");
        exit(0);
     }
  }
  fd[0] = fopen("pdf.tmp", "w+");
  if (!fd[0]) {
     printf("error opening file i\n");
     exit(0);
  }
  fd[1] = fopen(argv[4], "w");
  if (!fd[1]) {
     printf("error opening file i\n");
     exit(0);
  }
    
  /* computer frequencies */
  numSigs = 0;
  numPts = 0;
  for (x=0; x < XSIZ; x++) {
     for (y=0; y < YSIZ; y++) {
        totalMag = 0;
        for (i=0; i < numImages; i++) {
           fscanf(fp[i], "%d %d %d", &x, &y, &m);     /* x, y, magnitude */
           if (m) numSigs++;
           totalMag += m;      
        }
        if (totalMag > 0) {
           fprintf(fd[0], "%d %d %d\n", x, y, totalMag);            
           numPts++;
   /*  printf("x %d, y %d, M %d, pts %d\n", x, y, totalMag, numPts); ######*/
        }
     }
  }
  /* compute distribution */
  rewind(fd[0]);
  for (i=0; i < numPts; i++) {
     fscanf(fd[0], "%d %d %d", &x, &y, &totalMag); 
     fprintf(fd[1], "%d %d %.4e\n", x, y, (1.0*totalMag)/numSigs);
  }
  /* close files */
  for (i=0; i < numImages; i++) {
     fclose(fp[i]);
  }
  fclose(fd[0]);
  fclose(fd[1]);
}
